mkrootfs.sh.in 8.3 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169170171172173174175176177178179180181182183184185186187188189190191192193194195196197198199200201202203204205206207208209210211212213214215216217218219220221222223224225226227228229230231232233234235236237238239240241242243244245246247248249250251252253254255256257258259260261262263264
  1. #!/bin/sh
  2. #-
  3. # Copyright (c) 2013-2015 Juan Romero Pardines.
  4. # All rights reserved.
  5. #
  6. # Redistribution and use in source and binary forms, with or without
  7. # modification, are permitted provided that the following conditions
  8. # are met:
  9. # 1. Redistributions of source code must retain the above copyright
  10. # notice, this list of conditions and the following disclaimer.
  11. # 2. Redistributions in binary form must reproduce the above copyright
  12. # notice, this list of conditions and the following disclaimer in the
  13. # documentation and/or other materials provided with the distribution.
  14. #
  15. # THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
  16. # IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
  17. # OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
  18. # IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
  19. # INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
  20. # NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
  21. # DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
  22. # THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
  23. # (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
  24. # THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
  25. #-
  26. readonly PROGNAME=$(basename $0)
  27. readonly ARCH=$(uname -m)
  28. trap 'die "Interrupted! exiting..."' INT TERM HUP
  29. info_msg() {
  30. printf "\033[1m$@\n\033[m"
  31. }
  32. die() {
  33. echo "FATAL: $@"
  34. umount_pseudofs
  35. [ -d "$rootfs" ] && rm -rf $rootfs
  36. exit 1
  37. }
  38. usage() {
  39. cat <<_EOF
  40. Usage: $PROGNAME [options] <platform>
  41. Supported platforms: i686, i686-musl, x86_64, x86_64-musl,
  42. dockstar, bananapi, beaglebone, cubieboard2, cubietruck,
  43. odroid-u2, rpi, rpi2 (armv7), usbarmory
  44. Options
  45. -b <syspkg> Set an alternative base-system package (defaults to base-system)
  46. -c <dir> Set XBPS cache directory (defaults to \$PWD/xbps-cachedir-<arch>)
  47. -C <file> Full path to the XBPS configuration file
  48. -h Show this help
  49. -p <pkgs> Additional packages to install into the rootfs (separated by blanks)
  50. -r <repo> Set XBPS repository (may be set multiple times)
  51. -k <cmd> Call "cmd <ROOTFSPATH>" after building the rootfs
  52. -V Show version
  53. _EOF
  54. }
  55. mount_pseudofs() {
  56. for f in dev proc sys; do
  57. [ ! -d $rootfs/$f ] && mkdir -p $rootfs/$f
  58. mount -r --bind /$f $rootfs/$f
  59. done
  60. }
  61. umount_pseudofs() {
  62. for f in dev proc sys; do
  63. umount -f $rootfs/$f >/dev/null 2>&1
  64. done
  65. }
  66. run_cmd_target() {
  67. info_msg "Running $@ for target $_ARCH ..."
  68. if [ "${_TARGET_ARCH}" != "${_ARCH}" ]; then
  69. eval XBPS_TARGET_ARCH=${_TARGET_ARCH:=${_ARCH}} "$@"
  70. else
  71. eval XBPS_ARCH=${_ARCH} "$@"
  72. fi
  73. [ $? -ne 0 ] && die "Failed to run $@"
  74. }
  75. run_cmd() {
  76. info_msg "Running $@ ..."
  77. eval "$@"
  78. [ $? -ne 0 ] && die "Failed to run $@"
  79. }
  80. register_binfmt() {
  81. if [ "$ARCH" = "${_ARCH}" ]; then
  82. return 0
  83. fi
  84. mountpoint -q /proc/sys/fs/binfmt_misc || modprobe -q binfmt_misc; mount -t binfmt_misc binfmt_misc /proc/sys/fs/binfmt_misc
  85. case "${_ARCH}" in
  86. armv*)
  87. echo ':arm:M::\x7fELF\x01\x01\x01\x00\x00\x00\x00\x00\x00\x00\x00\x00\x02\x00\x28\x00:\xff\xff\xff\xff\xff\xff\xff\x00\xff\xff\xff\xff\xff\xff\xff\xff\xfe\xff\xff\xff:/usr/bin/qemu-arm-static:' > /proc/sys/fs/binfmt_misc/register
  88. cp -f $(which qemu-arm-static) $rootfs/usr/bin || die "failed to copy qemu-arm-static to the rootfs"
  89. ;;
  90. *)
  91. die "Unknown target architecture!"
  92. ;;
  93. esac
  94. }
  95. #
  96. # main()
  97. #
  98. while getopts "b:C:c:hp:r:k:V" opt; do
  99. case $opt in
  100. b) PKGBASE="$OPTARG";;
  101. C) XBPS_CONFFILE="-C $OPTARG";;
  102. c) XBPS_CACHEDIR="--cachedir=$OPTARG";;
  103. h) usage; exit 0;;
  104. p) EXTRA_PKGS="$OPTARG";;
  105. r) XBPS_REPOSITORY="$XBPS_REPOSITORY --repository=$OPTARG";;
  106. k) POST_HOOK="$OPTARG";;
  107. V) echo "$PROGNAME @@MKLIVE_VERSION@@"; exit 0;;
  108. esac
  109. done
  110. shift $(($OPTIND - 1))
  111. PLATFORM="$1"
  112. SUBPLATFORM=$PLATFORM
  113. case "$PLATFORM" in
  114. i686-musl) _TARGET_ARCH="$PLATFORM"; _ARCH="i686-musl";;
  115. i686) _TARGET_ARCH="$PLATFORM"; _ARCH="i686";;
  116. x86_64-musl) _TARGET_ARCH="$PLATFORM"; _ARCH="x86_64-musl";;
  117. x86_64) _TARGET_ARCH="$PLATFORM"; _ARCH="x86_64";;
  118. dockstar) _TARGET_ARCH="armv5tel"; _ARCH="armv5tel";;
  119. rpi-musl) _TARGET_ARCH="armv6l-musl"; _ARCH="armv6l";;
  120. rpi) _TARGET_ARCH="armv6l"; _ARCH="armv6l";;
  121. *-musl) _TARGET_ARCH="armv7l-musl"; _ARCH="armv7l";;
  122. *) _TARGET_ARCH="armv7l"; _ARCH="armv7l";;
  123. esac
  124. : ${XBPS_REPOSITORY:=--repository=http://repo.voidlinux.eu/current --repository=http://muslrepo.voidlinux.eu/current}
  125. : ${XBPS_CACHEDIR:=--cachedir=$PWD/xbps-cachedir-${_TARGET_ARCH}}
  126. case "$PLATFORM" in
  127. i686*|x86_64*) PKGBASE="base-voidstrap";;
  128. *) PKGBASE="base-system";;
  129. esac
  130. if [ -z "$PLATFORM" ]; then
  131. echo "$PROGNAME: platform was not set!"
  132. usage; exit 1
  133. fi
  134. case "$PLATFORM" in
  135. bananapi*) SUBPLATFORM=${PLATFORM%-*}; QEMU_BIN=qemu-arm-static;;
  136. beaglebone*) SUBPLATFORM=${PLATFORM%-*}; QEMU_BIN=qemu-arm-static;;
  137. cubieboard2*|cubietruck*) SUBPLATFORM=${PLATFORM%-*}; QEMU_BIN=qemu-arm-static;;
  138. dockstar*) SUBPLATFORM=${PLATFORM%-*}; QEMU_BIN=qemu-arm-static;;
  139. odroid-u2*) SUBPLATFORM=${PLATFORM%-*}; QEMU_BIN=qemu-arm-static;;
  140. rpi2*) SUBPLATFORM=rpi; QEMU_BIN=qemu-arm-static;;
  141. rpi*) SUBPLATFORM=${PLATFORM%-*}; QEMU_BIN=qemu-arm-static;;
  142. usbarmory*) SUBPLATFORM=${PLATFORM%-*}; QEMU_BIN=qemu-arm-static;;
  143. i686*) QEMU_BIN=qemu-i386-static;;
  144. x86_64*) QEMU_BIN=qemu-x86_64-static;;
  145. *) die "$PROGNAME: invalid platform!";;
  146. esac
  147. if [ "$(id -u)" -ne 0 ]; then
  148. die "need root perms to continue, exiting."
  149. fi
  150. #
  151. # Check for required binaries.
  152. #
  153. for f in chroot tar xbps-install xbps-reconfigure xbps-query; do
  154. if ! $f --version >/dev/null 2>&1; then
  155. die "$f binary is missing in your system, exiting."
  156. fi
  157. done
  158. if ! $QEMU_BIN -version >/dev/null 2>&1; then
  159. die "$QEMU_BIN binary is missing in your system, exiting."
  160. fi
  161. #
  162. # Check if package base-system is available.
  163. #
  164. rootfs=$(mktemp -d || die "FATAL: failed to create tempdir, exiting...")
  165. mkdir -p $rootfs/var/db/xbps/keys
  166. cp keys/*.plist $rootfs/var/db/xbps/keys
  167. run_cmd_target "xbps-install -S $XBPS_CONFFILE $XBPS_CACHEDIR $XBPS_REPOSITORY -r $rootfs"
  168. run_cmd_target "xbps-query -R -r $rootfs $XBPS_CONFFILE $XBPS_CACHEDIR $XBPS_REPOSITORY -ppkgver $PKGBASE"
  169. chmod 755 $rootfs
  170. case "$PLATFORM" in
  171. i686*|x86_64*) PKGS="${PKGBASE}" ;;
  172. *) PKGS="${PKGBASE} ${SUBPLATFORM}-base" ;;
  173. esac
  174. [ -n "$EXTRA_PKGS" ] && PKGS="${PKGS} ${EXTRA_PKGS}"
  175. mount_pseudofs
  176. #
  177. # Install base-system to the rootfs directory.
  178. #
  179. run_cmd_target "xbps-install -S $XBPS_CONFFILE $XBPS_CACHEDIR $XBPS_REPOSITORY -r $rootfs -y ${PKGS}"
  180. # Enable en_US.UTF-8 locale and generate it into the target rootfs.
  181. if [ -e $rootfs/etc/default/libc-locales ]; then
  182. LOCALE=en_US.UTF-8
  183. sed -e "s/\#\(${LOCALE}.*\)/\1/g" -i $rootfs/etc/default/libc-locales
  184. fi
  185. #
  186. # Reconfigure packages for target architecture: must be reconfigured
  187. # thru the qemu user mode binary.
  188. #
  189. if [ -n "${_ARCH}" ]; then
  190. info_msg "Reconfiguring packages for ${_ARCH} ..."
  191. case "$PLATFORM" in
  192. i686*|x86_64*)
  193. run_cmd "XBPS_ARCH=$_ARCH xbps-reconfigure -r $rootfs base-files"
  194. ;;
  195. *)
  196. register_binfmt
  197. run_cmd "xbps-reconfigure -r $rootfs base-files"
  198. run_cmd "chroot $rootfs env -i xbps-reconfigure -f base-files"
  199. rmdir $rootfs/usr/lib32
  200. rm -f $rootfs/lib32 $rootfs/lib64 $rootfs/usr/lib64
  201. ;;
  202. esac
  203. run_cmd "chroot $rootfs xbps-reconfigure -a"
  204. fi
  205. #
  206. # Setup default root password.
  207. #
  208. run_cmd "chroot $rootfs sh -c 'echo "root:voidlinux" | chpasswd -c SHA512'"
  209. if [ -n "$POST_HOOK" ]; then
  210. run_cmd "$POST_HOOK $rootfs"
  211. fi
  212. umount_pseudofs
  213. #
  214. # Cleanup rootfs.
  215. #
  216. rm -f $rootfs/etc/.pwd.lock 2>/dev/null
  217. rm -rf $rootfs/var/cache/* 2>/dev/null
  218. #
  219. # Generate final tarball.
  220. #
  221. arch=$ARCH
  222. if [ -n "${_ARCH}" ]; then
  223. rm -f $rootfs/usr/bin/$QEMU_BIN
  224. arch=${_ARCH}
  225. fi
  226. tarball=void-${PLATFORM}-rootfs-$(date '+%Y%m%d').tar.xz
  227. run_cmd "tar -cp --posix -C $rootfs . | xz -T0 -9 > $tarball "
  228. rm -rf $rootfs
  229. info_msg "Successfully created $tarball ($PLATFORM)"
  230. # vim: set ts=4 sw=4 et: